/*-----------------------------------------------------------------------*/
/* Low level disk I/O module skeleton for Petit FatFs (C)ChaN, 2009   
   Ͷ˵ĴI/OģǼPetit FatFsC2009   */
/*-----------------------------------------------------------------------*/

#include "diskio.h"
#include "stc15f2k60s2.h"
#include "spi.h"
#include "sd.h"
#include "def.h"



/*-----------------------------------------------------------------------*/
/* Initialize Disk Drive      
   ʼ    
   0 Ϊɹ  1 Ϊʧ                                       */
/*-----------------------------------------------------------------------*/

DSTATUS disk_initialize (void)
{
	DSTATUS stat;

	// Put your code here	   Ĵд
	 stat=SD_Init();	  //ʼSD ֵstat


	return stat;
}



/*-----------------------------------------------------------------------*/
/* Read Partial Sector
                                                      */
/*-----------------------------------------------------------------------*/

DRESULT disk_readp (
	BYTE* dest,			/* Pointer to the destination object ݵĵַ*/
	DWORD sector,		/* Sector number (LBA)  Ҫ*/
	WORD sofs,			/* Offset in the sector ƫֵ*/
	WORD count			/* Byte count (bit15:destination) ݸ*/
)
{
	DRESULT res;

	// Put your code here	 Ĵд

	u16 tmp,i;
	u8 r1;
    res=RES_ERROR;

	r1=SD_SendCmd(CMD17,sector<<9,0X01);//
	
	if(r1==0)//ָͳɹ
		{
		    while(SPI_SendByte(0xff)!=0xfe);  //ȴ
			 if(sofs)  //ƫ
			 {		  
			 for(i=0;i<sofs;i++)SPI_SendByte(0xff);  //ƫֵѭ
			 			      
			 for(i=0;i<count;i++) *(dest++)=SPI_SendByte(0xff);  //Ҫ		   
			 }
			 else   //ûƫֵ ƫֵΪ0
			 {
			   //ҪݸƸtmp
			   for(i=0;i<count;i++) *(dest++)=SPI_SendByte(0xff);  //Ҫ
			 }
			 tmp=512-sofs-count;  //ʣΪ   -ƫֵ-ȡ
			 for(i=0;i<tmp;i++)SPI_SendByte(0xff);// ʣѭ и


			//2αCRCdummy CRC
			  SPI_SendByte(0xff); 
              SPI_SendByte(0xff); 		   
		}
	  else  return res;	 //ָʧ

	SD_DisSelect();//ȡƬѡ
	res=RES_OK;	   //ݶȡɹ
	return res;
}



/*-----------------------------------------------------------------------*/
/* Write Partial Sector 
   д                                                 
   
   disk_writepдֻ
   дݵַ* buffڼscݡ

   ڱдʱҪע⣬FatFsڲúҪ밴µ˳
    buff ָһָ룬sc Ϊ0 ʱʾдгʼ
   sc Ϊ0 ʱʾдн
    buff ָһڴ滺ǽĶд*/
/*-----------------------------------------------------------------------*/

DRESULT disk_writep (
	BYTE* buff,		/* Pointer to the data to be written, NULL:Initiate/Finalize write operation ָݱд룬գ/д*/
	DWORD sc		/* Sector number (LBA) or Number of bytes to send LBAҪ͵ֽ*/
)
{
	DRESULT res;

//	 u8 r1;
//	 u16 t;
//	 u32 m;
	res = RES_ERROR;
  

	if (!buff) {						  //ָָ
		if (sc) {						  //scΪ0 дʼ

			// Initiate write process		  ʼд
//				  r1=SD_SendCmd(CMD24,sc<<9,0X01);
//				  if(r1!=0) return res;	 //Ӧȷ
//			      do
//		          {
//			        if(SPI_SendByte(0XFF)==0XFF)break;//OK	  ſݵȴSD׼
//			          m++;		  	
//		           }while(m<0XFFFFFF);//ȴ 
//	
//		          SPI_SendByte(0XFE);		  //
//				  res=RES_OK;

		} else {							 //scΪ0  ʾд

			// Finalize write process		  д

		           	//2αCRCdummy CRC
//				 	SPI_SendByte(0xFF);
//					SPI_SendByte(0xFF);
//					r1 = SPI_SendByte(0xFF);
//		
//					if( (r1&0x1f) != 0x05)//ȴSDӦ
//					{
//						SD_DisSelect();
//						return res;
//					}
//					//ȴ
//					while(!SPI_SendByte(0xFF));
//		
//					res = RES_OK;




		}
	} else {

		// Send data to the disk			  ݵ
//			for(t=0;t<512;t++)SPI_SendByte(*buff++);//ٶ,ٺʱ
//			
//		    res = RES_OK;


	}

	return res;
}


